<template>
    <div>
        <q-btn size="12px" @click="dialog = true"
               flat dense round icon="delete" color="negative"/>
        <q-dialog v-model="dialog">
            <div class="bg-base q-pa-md q-gutter-y-lg">
                <div class="text-h6 text-weight-light"> Remove User</div>
                <div class="text-body1">
                    Remove
                    <span class="text-negative"> {{ user.username }}</span>
                    with name
                    <span class="text-negative"> {{ user.name }}</span>
                    from the project?
                </div>
                <div class="row justify-between">
                    <q-btn label="back" flat @click="dialog=false"/>
                    <q-btn label="remove" outline color="negative" @click="Delete"/>
                </div>
            </div>
        </q-dialog>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {UserSafeResponse} from "src/classLibrary/APIModels/core/userSafeResponse";
import {SuccessMessage, WarnMessage} from "src/classLibrary/Utility";

@Component
export default class RemoveUserFromProjectDialog extends Vue {
    @Prop() user!: UserSafeResponse
    dialog = false;

    async Delete() {
        const token = await this.$auth.CoreToken;

        const pid = this.PersistentStore.StoreValue.project;
        const r = await this.$coreApi.QPost(`Project/${pid}/remove/${this.user.id}`, null, token);
        if (r.isSome()) {
            this.$q.notify(WarnMessage("Failed to remove user from project"));
            console.error(r.unwrap())
            return;
        }
        this.$q.notify(SuccessMessage(`Successfully removed ${this.user.name} from project!`));
        this.dialog = false;
        this.$emit('delete');
        return;


    }
}
</script>

<style lang='scss' scoped>

</style>
